# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ExternalValueSource(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'type': 'str',
        'parameters': 'list[FormserviceapiformsrendererexternalvalidationSourceParameters]',
        'is_pageable': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'type': 'type',
        'parameters': 'parameters',
        'is_pageable': 'isPageable'
    }

    def __init__(self, id=None, type=None, parameters=None, is_pageable=None):  # noqa: E501
        """ExternalValueSource - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._type = None
        self._parameters = None
        self._is_pageable = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if parameters is not None:
            self.parameters = parameters
        if is_pageable is not None:
            self.is_pageable = is_pageable

    @property
    def id(self):
        """Gets the id of this ExternalValueSource.  # noqa: E501


        :return: The id of this ExternalValueSource.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ExternalValueSource.


        :param id: The id of this ExternalValueSource.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this ExternalValueSource.  # noqa: E501


        :return: The type of this ExternalValueSource.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ExternalValueSource.


        :param type: The type of this ExternalValueSource.  # noqa: E501
        :type: str
        """
        allowed_values = ["scriptAction", "inventory", "inventoryTree", "systemAction", "dynamic"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def parameters(self):
        """Gets the parameters of this ExternalValueSource.  # noqa: E501


        :return: The parameters of this ExternalValueSource.  # noqa: E501
        :rtype: list[FormserviceapiformsrendererexternalvalidationSourceParameters]
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this ExternalValueSource.


        :param parameters: The parameters of this ExternalValueSource.  # noqa: E501
        :type: list[FormserviceapiformsrendererexternalvalidationSourceParameters]
        """

        self._parameters = parameters

    @property
    def is_pageable(self):
        """Gets the is_pageable of this ExternalValueSource.  # noqa: E501


        :return: The is_pageable of this ExternalValueSource.  # noqa: E501
        :rtype: bool
        """
        return self._is_pageable

    @is_pageable.setter
    def is_pageable(self, is_pageable):
        """Sets the is_pageable of this ExternalValueSource.


        :param is_pageable: The is_pageable of this ExternalValueSource.  # noqa: E501
        :type: bool
        """

        self._is_pageable = is_pageable

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExternalValueSource, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExternalValueSource):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
